<template>
  <div class="branch-selector-container" :style="{ zIndex }">
    <div :class="$style.slideDownContainer">
      <div
        @click="toggleOpened()"
        :class="[
          $style.branchSelector,
          isOpened && $style.isOpened,
          isVipMember && $style.vipTheme,
          { [$style.disabled]: !options.length }
        ]"
      >
        <span :class="[$style.pleaseSelect]">{{
          selectTitle || $t("placeholder.select")
        }}</span>
        <i :class="['ic-sm-arrow', $style.iconArrow]" />
      </div>
      <transition name="slide-down">
        <ul
          v-if="isOpened"
          :class="[
            { disabled: !options.length },
            $style.select,
            isVipMember && $style.vipTheme
          ]"
        >
          <template v-for="(option, index) in options">
            <li
              :class="[localValue === option.value && $style.isActive]"
              :key="index"
              @click="select(option.value)"
            >
              {{ option.text }}
            </li>
          </template>
        </ul>
      </transition>
    </div>
  </div>
</template>

<script>
import { mapGetters } from "vuex";

export default {
  props: {
    options: {
      type: Array,
      default: () => []
    },

    placeholder: {
      type: String,
      default: ""
    },

    value: {
      type: String,
      default: () => "",
      required: true
    },

    zIndex: {
      type: Number,
      default: 0
    }
  },

  data() {
    return {
      isOpened: false
    };
  },
  computed: {
    ...mapGetters("account", ["isVipMember"]),
    localValue: {
      get() {
        return this.value;
      },

      set(value) {
        this.$emit("input", value);
      }
    },

    selectTitle() {
      const selected = this.options.find(o => o.value === this.localValue);
      return selected ? selected.text : this.placeholder;
    }
  },

  methods: {
    toggleOpened(force) {
      if (this.options.length) {
        this.isOpened = typeof force === "undefined" ? !this.isOpened : force;
      }
    },

    select(value) {
      this.localValue = value;
      this.$nextTick(() => {
        this.toggleOpened(false);
      });
    }
  }
};
</script>

<style lang="scss" scoped>
.slide-down {
  &-enter-active {
    overflow: hidden;
    transition: max-height 0.5s ease-in-out;
  }
  &-leave-active {
    overflow: hidden;
    transition: max-height 0.5s cubic-bezier(0, 1, 0, 1);
  }

  &-enter,
  &-leave-to {
    max-height: 0;
  }

  &-enter-to,
  &-leave {
    max-height: 1000px;
  }
}
</style>

<style lang="scss" module>
:global(.branch-selector-container) {
  $height-mobile: 44px;
  $height-desktop: 50px;
  $font-size-desktop: 18px;
  $select-width-desktop: 100%;

  $border-radius: 2px;
  $border-width: 0.5px;

  @mixin border() {
    border: $border-width solid $color-pigeon-grey;
  }

  position: relative;

  @include media-breakpoint-up(md) {
    height: $height-desktop;
  }

  .slideDownContainer {
    width: 100%;
    border-radius: $border-radius;
    transform: translate3d(0, 0, 0); // fix safari border-radius issue

    @include media-breakpoint-up(md) {
      top: 0;
      left: 0;
      display: block;
      width: $select-width-desktop;
    }
  }

  .branchSelector {
    border-bottom: $border-width solid $color-pigeon-grey;

    width: 100%;
    height: $height-mobile;
    cursor: pointer;
    transform: translate3d(0, 0, 0); // fix safari font rendering issue
    background: transparent;
    color: $color-primary-black;
    overflow: hidden;

    &.isOpened {
      color: $color-white;
      background: $color-skm-red;
      border-radius: $border-radius $border-radius 0 0;

      .iconBranch {
        background: url(/static/images/ic-branch-active.svg) center no-repeat;
      }

      .iconArrow {
        transform: rotate(180deg);
      }
    }

    @include media-breakpoint-up(md) {
      width: $select-width-desktop;
      height: $height-desktop;
    }
  }

  // NOTE: should use svg font.
  .iconBranch {
    float: left;
    display: block;
    height: 100%;
    width: $height-mobile;
    background: url(/static/images/ic-branch.svg) center no-repeat;

    @include media-breakpoint-up(md) {
      width: $height-desktop;
    }
  }

  .iconArrow {
    float: right;
    margin-right: 20px;
    font-size: 10px;
    line-height: $height-mobile - $border-width * 2;
    transition: all 0.3s;

    @include media-breakpoint-up(md) {
      line-height: $height-desktop - $border-width * 2;
    }
  }

  .pleaseSelect {
    float: left;
    line-height: $height-mobile;
    padding-left: 20px;

    @include media-breakpoint-up(md) {
      font-size: $font-size-desktop;
      line-height: $height-desktop;
    }
  }

  .disabled {
    color: $color-silver-grey;
  }

  .select {
    position: absolute;
    width: 100%;
    padding: 0;
    margin: 0;
    cursor: pointer;
    color: $color-primary-black;
    background: $color-white;
    height: 215px;
    overflow-y: auto;
    border-bottom: 1px solid $color-pigeon-grey;

    @include media-breakpoint-up(md) {
      height: 230px;
    }

    li {
      position: relative;
      z-index: 1;
      @include border();
      border-top-width: 0;

      padding: 11px 10px 11px 20px;
      list-style: none;
      // min-height: $height-mobile;
      // line-height: $height-mobile;

      &:last-child {
        border-radius: 0 0 $border-radius $border-radius;
      }

      &.isActive {
        background: $color-skm-red;
        color: $color-white;
      }
    }

    @include media-breakpoint-up(md) {
      top: $height-desktop;
      width: $select-width-desktop;

      li {
        font-size: $font-size-desktop;
        // min-height: $height-desktop;
        // line-height: $height-desktop;
      }
    }
  }

  .vipTheme {
    &.select {
      li {
        &.isActive {
          background: $color-skm-gold;
        }
      }
    }
    &.submit,
    &.isOpened {
      background: $color-skm-gold;
    }
  }
}
</style>
